/*     */ package petascope.wcs2.extensions;
/*     */ 
/*     */ import java.io.PrintStream;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import petascope.core.DbMetadataSource;
/*     */ import petascope.core.Metadata;
/*     */ import petascope.exceptions.ExceptionCode;
/*     */ import petascope.exceptions.RasdamanException;
/*     */ import petascope.exceptions.WCPSException;
/*     */ import petascope.exceptions.WCSException;
/*     */ import petascope.util.Pair;
/*     */ import petascope.util.WcsUtil;
/*     */ import petascope.util.ras.RasQueryResult;
/*     */ import petascope.util.ras.RasUtil;
/*     */ import petascope.wcps.server.core.DomainElement;
/*     */ import petascope.wcps.server.core.WCPS;
/*     */ import petascope.wcs2.parsers.GetCoverageMetadata;
/*     */ import petascope.wcs2.parsers.GetCoverageRequest;
/*     */ import petascope.wcs2.parsers.GetCoverageRequest.DimensionSlice;
/*     */ import petascope.wcs2.parsers.GetCoverageRequest.DimensionSubset;
/*     */ import petascope.wcs2.parsers.GetCoverageRequest.DimensionTrim;
/*     */ 
/*     */ public abstract class AbstractFormatExtension
/*     */   implements FormatExtension
/*     */ {
/*     */   protected static WCPS wcps;
/*     */   protected crsProperties prop;
/*     */ 
/*     */   public AbstractFormatExtension()
/*     */   {
/*  52 */     this.prop = new crsProperties();
/*     */   }
/*     */ 
/*     */   protected void setBounds(GetCoverageRequest request, GetCoverageMetadata m, DbMetadataSource meta)
/*     */     throws WCSException
/*     */   {
/*  59 */     Pair pair = executeRasqlQuery(request, m, meta, "sdom", null);
/*  60 */     if (pair.fst != null) {
/*  61 */       RasQueryResult res = new RasQueryResult(pair.fst);
/*  62 */       if (res.getScalars().isEmpty())
/*     */         return;
/*  64 */       Pair bounds = WcsUtil.sdom2bounds((String)res.getScalars().get(0));
/*  65 */       m.setAxisLabels((String)pair.snd);
/*  66 */       m.setLow((String)bounds.fst);
/*  67 */       m.setHigh((String)bounds.snd);
/*     */     }
/*     */   }
/*     */ 
/*     */   protected Pair<Object, String> executeRasqlQuery(GetCoverageRequest request, GetCoverageMetadata m, DbMetadataSource meta, String format, String params)
/*     */     throws WCSException
/*     */   {
/*  82 */     if (wcps == null) {
/*     */       try {
/*  84 */         wcps = new WCPS(meta);
/*     */       } catch (Exception ex) {
/*  86 */         throw new WCSException(ExceptionCode.InternalComponentError, "Error initializing WCPS engine", ex);
/*     */       }
/*     */     }
/*     */ 
/*  90 */     Pair pair = constructWcpsQuery(request, m.getMetadata(), format, params);
/*  91 */     String rquery = null;
/*     */     try {
/*  93 */       rquery = RasUtil.abstractWCPSToRasql((String)pair.fst, wcps, this.prop);
/*     */     } catch (WCPSException ex) {
/*  95 */       throw new WCSException(ExceptionCode.WcpsError, "Error converting WCPS query to rasql query", ex);
/*     */     }
/*  97 */     Object res = null;
/*     */     try {
/*  99 */       if (("sdom".equals(format)) && (!(rquery.contains(":"))))
/* 100 */         res = null;
/*     */       else
/* 102 */         res = RasUtil.executeRasqlQuery(rquery);
/*     */     }
/*     */     catch (RasdamanException ex) {
/* 105 */       throw new WCSException(ExceptionCode.RasdamanRequestFailed, "Error executing rasql query", ex);
/*     */     }
/*     */ 
/* 108 */     System.out.println("format is " + format);
/* 109 */     System.out.println("crs is " + this.prop.CRS);
/*     */ 
/* 111 */     return Pair.of(res, pair.snd);
/*     */   }
/*     */ 
/*     */   protected Pair<String, String> constructWcpsQuery(GetCoverageRequest req, Metadata cov, String format, String params)
/*     */   {
/* 121 */     String axes = "";
/* 122 */     Iterator dit = cov.getDomainIterator();
/* 123 */     while (dit.hasNext()) {
/* 124 */       axes = axes + ((DomainElement)dit.next()).getName() + " ";
/*     */     }
/* 126 */     String proc = "c";
/*     */ 
/* 129 */     for (GetCoverageRequest.DimensionSubset subset : req.getSubsets()) {
/* 130 */       String dim = subset.getDimension();
/* 131 */       DomainElement de = cov.getDomainByName(dim);
/* 132 */       String crs = "CRS:1";
/* 133 */       if (subset.getCrs() != null) {
/* 134 */         crs = subset.getCrs();
/*     */       }
/*     */ 
/* 137 */       if (subset instanceof GetCoverageRequest.DimensionTrim) {
/* 138 */         GetCoverageRequest.DimensionTrim trim = (GetCoverageRequest.DimensionTrim)subset;
/* 139 */         proc = "trim(" + proc + ",{" + dim + ":\"" + crs + "\" (" + trim.getTrimLow() + ":" + trim.getTrimHigh() + ")})";
/*     */       }
/* 141 */       else if (subset instanceof GetCoverageRequest.DimensionSlice) {
/* 142 */         GetCoverageRequest.DimensionSlice slice = (GetCoverageRequest.DimensionSlice)subset;
/* 143 */         proc = "slice(" + proc + ",{" + dim + "(" + slice.getSlicePoint() + ")})";
/* 144 */         axes = axes.replaceFirst(dim + " ?", "");
/*     */       }
/*     */     }
/* 147 */     if (params != null) {
/* 148 */       format = format + ", \"" + params + "\"";
/*     */     }
/* 150 */     String query = "for c in (" + req.getCoverageId() + ") return encode(" + proc + ", \"" + format + "\")";
/* 151 */     return Pair.of(query, axes.trim());
/*     */   }
/*     */ }

/* Location:           /home/dimitar/projects/rasdaman/community/backup/classes/
 * Qualified Name:     petascope.wcs2.extensions.AbstractFormatExtension
 * JD-Core Version:    0.5.3
 */